%
% Ilustracni priklad 3d konzola, nelinearni plasticky vypocet
% (c) Borek Patzak, 2014
%
e=10.0;
nu=0.15;
Ry=2;
mode = 2;
limit=1.e-1;

step_color=['k'; 'b'; 'm'; 'r'];


global nnode = 90
global ndof  = 3
global nelem = 32
global nelnode = 8
global neq;
global uneq;
global pneq;
global id; global lm;
global bc; global elnode;
% pole kodovych cisel uzlu (0 volny posun, 1 podpora)
bc=zeros(90,3);
for i=1:10
  bc(i,1)=1;
  bc(i,2)=0;
  bc(i,3)=0;
end;
bc(1,2) = 1; bc(1,3)=1; bc(6,3) = 1;
bc(2,2) = 1; bc(3,2)=1; bc(4,2)=1; bc(5,2)=1;
%prescribe horizontal displacements at the end
for i=81:90
    bc(i,1)=1;
end;


%pole uzlu prvku
elnode=zeros(32,8);
for i=1:8
elnode((i-1)*4+1,:)=[(i-1)*10+1, (i-1)*10+11, (i-1)*10+16, (i-1)*10+6, (i-1)*10+2, (i-1)*10+12, (i-1)*10+17, (i-1)*10+7];
elnode((i-1)*4+2,:)=[(i-1)*10+2, (i-1)*10+12, (i-1)*10+17, (i-1)*10+7, (i-1)*10+3, (i-1)*10+13, (i-1)*10+18, (i-1)*10+8];
elnode((i-1)*4+3,:)=[(i-1)*10+3, (i-1)*10+13, (i-1)*10+18, (i-1)*10+8, (i-1)*10+4, (i-1)*10+14, (i-1)*10+19, (i-1)*10+9];
elnode((i-1)*4+4,:)=[(i-1)*10+4, (i-1)*10+14, (i-1)*10+19, (i-1)*10+9, (i-1)*10+5, (i-1)*10+15, (i-1)*10+20, (i-1)*10+10];
end;


%pole souradnic
xyz=zeros(90,3);
for j=1:9
for k=1:2
for i=1:5
  xyz(i+(k-1)*5+(j-1)*10, :)=[j-1,k-1,i-1];
end
end
end

%deformovane souradnice pro vykresleni
xyzd=zeros(90,3);


preproc;
%
subplot(2,1,1);
title ("Prubeh napeti ve vetknuti")
subplot(2,1,2);
title("Deformovany tvar")



%debugging geometry plot
subplot(2,1,2)
hold on;
if mode == 2
for i=1:32
  lspace_plot(i, xyz, elnode, "b-x");
end
end
view([0 -1 0])


%solve the problem
k=zeros(neq);
be=zeros(6,24,8); % be on element, same for all
jac=zeros(8); % precomputed jacobians at IP, same for all
ru = zeros(uneq,1);
f  = zeros(uneq,1);
df = zeros(uneq,1);
r=zeros(neq,1);
dr=zeros(neq,1); %prescribed increment (displacement controll)
rp=zeros(neq,1);
ri=zeros(neq,1);
sig=zeros(6, nelem,8); % napeti
epsp=zeros(6, nelem,8); %plasticka (rovnovazna) deformace
epsp2=zeros(6, nelem,8); %plasticka (ne-rovnovazna) deformace
fint =zeros(uneq,1);
% prescribe horizontal x-displacements to nodes 80-90 (bending) as rotation
roti = 0.8;
  dr(id(81,1))=roti*(-2.0); dr(id(86,1))=roti*(-2.0);
  dr(id(82,1))=roti*(-1.0); dr(id(87,1))=roti*(-1.0);
  dr(id(83,1))=roti*(0.0); dr(id(88,1))=roti*(0.0);
  dr(id(84,1))=roti*(1.0); dr(id(89,1))=roti*(1.0);
  dr(id(85,1))=roti*(2.0); dr(id(90,1))=roti*(2.0);

% load increment (currently none)
%for i=1:10
%	df(uneq-(i-1)*3)=-0.1;
%end

%souradnice uzlu (krychle o hrane 1)
xyze=[0,0,0;     1,0,0;	 1,1,0;	 0,1,0;	 0,0,1;	 1,0,1;	 1,1,1;	 0,1,1];
ke=lspace_k(xyze,e,nu);

for i=1:nelem
  k=assembly(k,ke,i);
end

kuu=k(pneq+1:neq,pneq+1:neq);
kuuinv=inv(kuu);

%integracni body (lspace)
lc = [-0.577350269189626, -0.577350269189626, -0.577350269189626;
      -0.577350269189626, -0.577350269189626, 0.577350269189626;
      -0.577350269189626, 0.577350269189626, -0.577350269189626;
      -0.577350269189626, 0.577350269189626,  0.577350269189626;
       0.577350269189626, -0.577350269189626, -0.577350269189626;
       0.577350269189626, -0.577350269189626,  0.577350269189626;
       0.577350269189626,  0.577350269189626, -0.577350269189626;
       0.577350269189626,  0.577350269189626,  0.577350269189626];
% integracni vahy
w=[1;1;1;1;1;1;1;1];

%precompute element be
for ii=1:8% loop over integration points
   be(:,:,ii)=lspace_b(xyze, lc(ii,:));
   jac(ii) = det(lspace_jacobian(lc(ii,:), xyze));
end


%cyklus prez prirustky zatizeni
for i=1:4
  r =r + dr;                    % add p[rescribed displacement increment
  res=df-k(pneq+1:neq,1:pneq)*dr(1:pneq);
%inicializace citace iteraci
  nite=0;
  rh=[];

% iterace rovnovahy
  printf("Load increment: %d\n=======================\n", i);
  while (norm(res) > limit)
    nite=nite+1;
    ru=kuuinv*res;
    ri(pneq+1:neq) = ru;
    r = r+ri;
    %dopocteni deformaci a napeti, sestaveni fint
      fint=zeros(neq,1);
    for ie=1:nelem
          re=r(lm(ie,:));
          for ii=1:8% loop over integration points
                  %be=lspace_b(xyze, lc(ii,:));
                   eps=be(:,:,ii)*re;
                   [a,b] = cp (eps, epsp(:, ie,ii), e, nu, Ry);
                   sig(:,ie, ii) = a;
                   epsp2(:,ie,ii) = b;
                   fint(lm(ie,:)) = fint(lm(ie,:)) + be(:,:,ii)'*sig(:,ie,ii)*jac(ii)*w(ii);
          end % loop over ip
    end % loop over elements
    res = f+df-fint(pneq+1:neq);
    rh(nite)=norm(res); %remember for convergence plot
    printf("%d, %e\n", nite, norm(res));
  end % while
  epsp=epsp2;

  if mode == 0 % ld-lpot
    plot ([r(270)], [fint(270)], "r+")
  elseif mode == 1 %convergence plot
    semilogy (rh)
  elseif mode == 2 %displacement+napeti

    %plot deformed shape
    subplot (2,1,2)
    hold on
    for i=1:90
      for j=1:3
      xyzd(i,j)=xyz(i,j)+r(id(i,j))*0.1;
      end
    end
    for i=1:32
        lspace_plot(i, xyzd, elnode, 'r-x')
    end
    view([0 -1 0])

    %dopocteni deformaci a napeti ve vetknuti (elements 1-4):
    %d=isole3d(e,nu);
    subplot (2,1,1)
    hold on
    for ie=1:4
        re=r(lm(ie,:));
         %be=lspace_b(xyze, lcs(1,:));
         %epse=be*re;
         %se=d*epse/10.;
         se=sig(:,ie, 2);
         plot3([0; se(1); se(1); 0], [0;0;0;0], [(ie-1);(ie-1);(ie-1)+0.5;(ie-1)+0.5], "k");
         %be=lspace_b(xyze, lcs(2,:));
         %epse=be*re;
         %se=d*epse/10.;
         se=sig(:,ie, 1);
         plot3([0; se(1); se(1); 0], [0;0;0;0], [(ie-1)+0.50;(ie-1)+0.50;(ie-1)+1;(ie-1)+1], "k");
    end %ie
    view([0 -1 0])

  end %if mode
  [nite; fint(4)]
  f=f+df;
end %loop over load steps
view([0 -1 0])
hold off
pause
