% funkce pocita J2 - druhy invariant deviatorickeho napeti
%
% In:  s - full stress vector 
% Out: v - J2
function v = j2(s)

v1 = ( ( s(1) - s(2) ) * ( s(1) - s(2) ) );
v2 = ( ( s(2) - s(3) ) * ( s(2) - s(3) ) );
v3 = ( ( s(3) - s(1) ) * ( s(3) - s(1) ) );

v = ( 1. / 6. ) * ( v1 + v2 + v3 ) + s(4) * s(4) + s(5) * s(5) + s(6) * s(6);

